<?php

$cmd_args = \getopt("d:");

if (count($cmd_args) !== 1) {
	echo "Usage: php convert_templates.php -d path_to_sign_templates_directory";
}
else {
	$dir = $cmd_args['d'];
	$tempalate_def = "$dir/templates.sii";

	echo "Converting sign templates definition file '$tempalate_def'\n";
	convert_template_defs($tempalate_def);
	
	foreach (\scandir("$dir/template") as $file) {
		if (! \preg_match('/.sii$/', $file)) {
			// exclude non sii files
			continue;
		}

		anonymize("$dir/template/$file");
	}
}

/**
 * Convert sign templates definition file to new format.
 **/ 
function convert_template_defs($path)
{
	$in_file = \fopen($path, 'r');
	$out_file = \fopen("$path.tmp", 'w');
	
	$content = \fread($in_file, \filesize($path));
	
	\fwrite($out_file, "SiiNunit\n{\n");

	foreach (\explode("\n", $content) as $line) {
		$matches = array();

		if (\preg_match('/template\_paths\[[0-9]+\]\: (\"[^\.]+\.([.\w]+)\.sii\")/', $line, $matches)) {
			if (\count($matches) > 2) {
				\fwrite($out_file, "sign_template_def : sign_templ.$matches[2] {\n\tpath: $matches[1]\n}\n\n");
			}
		}
	}
	
	\fwrite($out_file, "}");

	\fclose($out_file);
	\fclose($in_file);
	
	\unlink($path);
	\rename("$path.tmp", $path);
}

/**
 * Anonymize sign template in given file.
 **/ 
function anonymize($path) {
	echo "Anonymizing units in file '$path'\n";

	$in = \fopen($path, 'r');
	$content = \fread($in, \filesize($path));
	\fclose($in);
	
	$content = \preg_replace('/sign\_templ\.([^ ]+)/', '.$1', $content);
	
	$out = \fopen($path, 'w+');
	\fwrite($out, $content);
	\fclose($out);	
}

?>